Summary:	Multithreaded IO generation tool
Name:		fio
Version:	3.35
Release:	1%{?dist}
License:	GPLv2
URL:		http://git.kernel.dk/?p=fio.git;a=summary
Source0:	http://brick.kernel.dk/snaps/%{name}-%{version}.tar.bz2

BuildRequires:	gcc make
BuildRequires:	libaio-devel numactl-devel librdmacm-devel
BuildRequires:	zlib-devel python3-devel libnbd-devel libcurl-devel
BuildRequires:	openssl-devel

%global __provides_exclude_from ^%{_libdir}/fio/

Recommends:     %{name}-engine-libaio
Recommends:     %{name}-engine-http
Recommends:     %{name}-engine-nbd
Recommends:     %{name}-engine-rdma

%description
Fio was originally written to save me the hassle of writing
special test case programs when I wanted to test a specific
workload, either for performance reasons or to find/reproduce
a bug. The process of writing such a test app can be tiresome,
especially if you have to do it often. Hence I needed a tool
that would be able to simulate a given I/O workload without
resorting to writing a tailored test case again and again.

%package engine-libaio
Summary:        Linux libaio engine for %{name}.
Requires:       %{name} = %{version}-%{release}

%description engine-libaio
Linux libaio engine for %{name}.

%package engine-http
Summary:        HTTP engine for %{name}.
Requires:       %{name} = %{version}-%{release}

%description engine-http
HTTP engine for %{name}.

%package engine-nbd
Summary:        Network Block Device engine for %{name}.
Requires:       %{name} = %{version}-%{release}

%description engine-nbd
Network Block Device engine for %{name}.

%package engine-rdma
Summary:        RDMA engine for %{name}.
Requires:       %{name} = %{version}-%{release}

%description engine-rdma
RDMA engine for %{name}.

%prep
%autosetup -p1

pathfix.py -i %{__python3} -pn \
 tools/fio_jsonplus_clat2csv \
 tools/fiologparser.py \
 tools/hist/*.py \
 tools/plot/fio2gnuplot \
 t/steadystate_tests.py

sed -e 's,/usr/local/lib/,%{_libdir}/,g' -i os/os-linux.h

%build
./configure --disable-optimizations --enable-libnbd --dynamic-libengines
EXTFLAGS="$RPM_OPT_FLAGS" LDFLAGS="$RPM_LD_FLAGS" %make_build

%install
make install prefix=%{_prefix} mandir=%{_mandir} libdir=%{_libdir}/fio DESTDIR=$RPM_BUILD_ROOT INSTALL="install -p"

%files
%license COPYING
%doc README.rst REPORTING-BUGS HOWTO.rst examples
%doc MORAL-LICENSE GFIO-TODO SERVER-TODO STEADYSTATE-TODO
%{_bindir}/*
%dir %{_libdir}/fio/
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*
%{_mandir}/man1/*

%files engine-http
%{_libdir}/fio/fio-http.so

%files engine-libaio
%{_libdir}/fio/fio-libaio.so

%files engine-nbd
%{_libdir}/fio/fio-nbd.so

%files engine-rdma
%{_libdir}/fio/fio-rdma.so

%changelog
* Wed Jun 21 2023 kianli <kianli@tencent.com> - 3.35-1
- Upgrade to 3.35

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.33-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.33-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Nov 28 2022 cunshunxia <cunshunxia@tencent.com> - 3.33-1
- initial build
